#include "pch.h"
#include "referencable.h"

CReferencable::CReferencable(void)
: m_refCounter(0)
{
}

CReferencable::~CReferencable(void)
{
}

unsigned int CReferencable::addRef() {
	++m_refCounter;
	return m_refCounter;
}

unsigned int CReferencable::release() {
	--m_refCounter;
	if (m_refCounter == 0) {
		delete this;
		return 0;
	} else {
		return m_refCounter;
	}
}
